com.fasterxml.jackson.databind.type

## Class PlaceholderForType

- java.lang.Object
- - com.fasterxml.jackson.core.type.ResolvedType
  - - com.fasterxml.jackson.databind.JavaType
    - - com.fasterxml.jackson.databind.type.TypeBase
      - - com.fasterxml.jackson.databind.type.PlaceholderForType

All Implemented Interfaces:
  JsonSerializable, Serializable, Type

    public class PlaceholderForType
    extends TypeBase

Helper type used when introspecting bindings for already resolved types, needed for specialization.

Since:
  2.8.11
See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.JsonSerializable

`JsonSerializable.Base`

### Field Summary

Fields
`protected JavaType` `_actualType` Type assigned during wildcard resolution (which follows type structure resolution)
`protected int` `_ordinal`

### Fields inherited from class com.fasterxml.jackson.databind.type.TypeBase

`_bindings, _superClass, _superInterfaces`

### Fields inherited from class com.fasterxml.jackson.databind.JavaType

`_asStatic, _class, _hash, _typeHandler, _valueHandler`

### Constructor Summary

Constructors
Constructor and Description
`PlaceholderForType(int ordinal)`

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`protected JavaType` `_narrow(Class<?> subclass)` Deprecated.
`JavaType` `actualType()`
`void` `actualType(JavaType t)`
`protected String` `buildCanonicalName()`
`boolean` `equals(Object o)`
`StringBuilder` `getErasedSignature(StringBuilder sb)` Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.
`StringBuilder` `getGenericSignature(StringBuilder sb)`
`boolean` `isContainerType()`
`JavaType` `refine(Class<?> rawType, TypeBindings bindings, JavaType superClass, JavaType[] superInterfaces)` Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
`String` `toString()`
`JavaType` `withContentType(JavaType contentType)` Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one.
`JavaType` `withContentTypeHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.
`JavaType` `withContentValueHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
`JavaType` `withStaticTyping()` Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use.
`JavaType` `withTypeHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
`JavaType` `withValueHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

### Methods inherited from class com.fasterxml.jackson.databind.type.TypeBase

`_bogusSuperClass, _classSignature, containedType, containedTypeCount, containedTypeName, findSuperType, findTypeParameters, getBindings, getInterfaces, getSuperClass, serialize, serializeWithType, toCanonical`

### Methods inherited from class com.fasterxml.jackson.databind.JavaType

`containedTypeOrUnknown, forcedNarrowBy, getContentType, getContentTypeHandler, getContentValueHandler, getErasedSignature, getGenericSignature, getKeyType, getParameterSource, getRawClass, getReferencedType, getTypeHandler, getValueHandler, hasContentType, hasGenericTypes, hasHandlers, hashCode, hasRawClass, hasValueHandler, isAbstract, isArrayType, isCollectionLikeType, isConcrete, isEnumImplType, isEnumType, isFinal, isInterface, isJavaLangObject, isMapLikeType, isPrimitive, isThrowable, isTypeOrSubTypeOf, isTypeOrSuperTypeOf, useStaticType, withHandlersFrom`

### Methods inherited from class com.fasterxml.jackson.core.type.ResolvedType

`isReferenceType`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.lang.reflect.Type

`getTypeName`

### Field Detail

#### _ordinal

    protected final int _ordinal

#### _actualType

    protected JavaType _actualType

Type assigned during wildcard resolution (which follows type structure resolution)

### Constructor Detail

#### PlaceholderForType

    public PlaceholderForType(int ordinal)

### Method Detail

#### actualType

    public JavaType actualType()

#### actualType

    public void actualType(JavaType t)

#### buildCanonicalName

    protected String buildCanonicalName()

Overrides:
  `buildCanonicalName` in class `TypeBase`

#### getGenericSignature

    public StringBuilder getGenericSignature(StringBuilder sb)

Specified by:
  `getGenericSignature` in class `TypeBase`
Parameters:
  `sb` - StringBuilder to append signature to
Returns:
  StringBuilder that was passed in; returned to allow call chaining

#### getErasedSignature

    public StringBuilder getErasedSignature(StringBuilder sb)

Description copied from class: `JavaType`
Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.

Specified by:
  `getErasedSignature` in class `TypeBase`
Parameters:
  `sb` - StringBuilder to append signature to
Returns:
  StringBuilder that was passed in; returned to allow call chaining

#### withTypeHandler

    public JavaType withTypeHandler(Object h)

Description copied from class: `JavaType`
"Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.

Specified by:
  `withTypeHandler` in class `JavaType`
Returns:
  Newly created type instance

#### withContentTypeHandler

    public JavaType withContentTypeHandler(Object h)

Description copied from class: `JavaType`
Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.

Specified by:
  `withContentTypeHandler` in class `JavaType`
Returns:
  Newly created type instance, with given

#### withValueHandler

    public JavaType withValueHandler(Object h)

Description copied from class: `JavaType`
Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

Specified by:
  `withValueHandler` in class `JavaType`
Returns:
  Newly created type instance

#### withContentValueHandler

    public JavaType withContentValueHandler(Object h)

Description copied from class: `JavaType`
Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.

Specified by:
  `withContentValueHandler` in class `JavaType`
Returns:
  Newly created type instance

#### withContentType

    public JavaType withContentType(JavaType contentType)

Description copied from class: `JavaType`
Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one. If content type is already set to given type, `this` is returned. If type does not have a content type (which is the case with `SimpleType`), `IllegalArgumentException` will be thrown.

Specified by:
  `withContentType` in class `JavaType`
Returns:
  Newly created type instance

#### withStaticTyping

    public JavaType withStaticTyping()

Description copied from class: `JavaType`
Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use. The main use case is to allow forcing of specific root value serialization type, and specifically in resolving serializers for contained types (element types for arrays, Collections and Maps).

Specified by:
  `withStaticTyping` in class `JavaType`

#### refine

    public JavaType refine(Class<?> rawType,
                           TypeBindings bindings,
                           JavaType superClass,
                           JavaType[] superInterfaces)

Description copied from class: `JavaType`
Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.

Specified by:
  `refine` in class `JavaType`

#### _narrow

    @Deprecated
    protected JavaType _narrow(Class<?> subclass)

Deprecated.

Specified by:
  `_narrow` in class `JavaType`

#### isContainerType

    public boolean isContainerType()

Specified by:
  `isContainerType` in class `JavaType`
Returns:
  True if type represented is a container type; this includes array, Map and Collection types.

#### toString

    public String toString()

Specified by:
  `toString` in class `JavaType`

#### equals

    public boolean equals(Object o)

Specified by:
  `equals` in class `JavaType`